Index: kernel/arch/sparc64/Makefile.inc
===================================================================
--- kernel/arch/sparc64/Makefile.inc	(revision aa85487c600b0fee35e8be1a6edd9b5b1a9a0646)
+++ kernel/arch/sparc64/Makefile.inc	(revision 2e992773e5f019775f8da23f506b24fe7ec905b0)
@@ -75,4 +75,5 @@
 	arch/$(KARCH)/src/dummy.s \
 	arch/$(KARCH)/src/mm/$(USARCH)/as.c \
+	arch/$(KARCH)/src/mm/cache.S \
 	arch/$(KARCH)/src/mm/$(USARCH)/frame.c \
 	arch/$(KARCH)/src/mm/page.c \
@@ -92,11 +93,5 @@
 	arch/$(KARCH)/src/drivers/sgcn.c \
 	arch/$(KARCH)/src/drivers/pci.c \
-	arch/$(KARCH)/src/drivers/fhc.c \
-	arch/$(KARCH)/src/trap/$(USARCH)/interrupt.c
-
-ifeq ($(USARCH),sun4u)
-	ARCH_SOURCES += \
-	        arch/$(KARCH)/src/mm/cache.S
-endif
+	arch/$(KARCH)/src/drivers/fhc.c
 
 ifeq ($(USARCH),sun4v)
@@ -113,6 +108,6 @@
 ifeq ($(CONFIG_SMP),y)
 	ARCH_SOURCES += \
-		arch/$(KARCH)/src/smp/$(USARCH)/smp.c \
-		arch/$(KARCH)/src/smp/$(USARCH)/ipi.c
+		arch/$(KARCH)/src/smp/ipi.c \
+		arch/$(KARCH)/src/smp/smp.c
 endif
 
Index: kernel/arch/sparc64/include/atomic.h
===================================================================
--- kernel/arch/sparc64/include/atomic.h	(revision aa85487c600b0fee35e8be1a6edd9b5b1a9a0646)
+++ kernel/arch/sparc64/include/atomic.h	(revision 2e992773e5f019775f8da23f506b24fe7ec905b0)
@@ -27,5 +27,5 @@
  */
 
-/** @addtogroup sparc64
+/** @addtogroup sparc64	
  * @{
  */
@@ -45,47 +45,40 @@
  *
  * @param val Atomic variable.
- * @param i   Signed value to be added.
+ * @param i Signed value to be added.
  *
  * @return Value of the atomic variable as it existed before addition.
- *
  */
-static inline atomic_count_t atomic_add(atomic_t *val, atomic_count_t i)
+static inline long atomic_add(atomic_t *val, int i)
 {
-	atomic_count_t a;
-	atomic_count_t b;
-	
+	uint64_t a, b;
+
 	do {
-		volatile uintptr_t ptr = (uintptr_t) &val->count;
-		
-		a = *((atomic_count_t *) ptr);
+		volatile uintptr_t x = (uint64_t) &val->count;
+
+		a = *((uint64_t *) x);
 		b = a + i;
-		
-		asm volatile (
-			"casx %0, %2, %1\n"
-			: "+m" (*((atomic_count_t *) ptr)),
-		      "+r" (b)
-		    : "r" (a)
-		);
+		asm volatile ("casx %0, %2, %1\n" : "+m" (*((uint64_t *)x)),
+		    "+r" (b) : "r" (a));
 	} while (a != b);
-	
+
 	return a;
 }
 
-static inline atomic_count_t atomic_preinc(atomic_t *val)
+static inline long atomic_preinc(atomic_t *val)
 {
 	return atomic_add(val, 1) + 1;
 }
 
-static inline atomic_count_t atomic_postinc(atomic_t *val)
+static inline long atomic_postinc(atomic_t *val)
 {
 	return atomic_add(val, 1);
 }
 
-static inline atomic_count_t atomic_predec(atomic_t *val)
+static inline long atomic_predec(atomic_t *val)
 {
 	return atomic_add(val, -1) - 1;
 }
 
-static inline atomic_count_t atomic_postdec(atomic_t *val)
+static inline long atomic_postdec(atomic_t *val)
 {
 	return atomic_add(val, -1);
@@ -102,16 +95,12 @@
 }
 
-static inline atomic_count_t test_and_set(atomic_t *val)
+static inline long test_and_set(atomic_t *val)
 {
-	atomic_count_t v = 1;
-	volatile uintptr_t ptr = (uintptr_t) &val->count;
-	
-	asm volatile (
-		"casx %0, %2, %1\n"
-		: "+m" (*((atomic_count_t *) ptr)),
-	      "+r" (v)
-	    : "r" (0)
-	);
-	
+	uint64_t v = 1;
+	volatile uintptr_t x = (uint64_t) &val->count;
+
+	asm volatile ("casx %0, %2, %1\n" : "+m" (*((uint64_t *) x)),
+	    "+r" (v) : "r" (0));
+
 	return v;
 }
@@ -119,27 +108,24 @@
 static inline void atomic_lock_arch(atomic_t *val)
 {
-	atomic_count_t tmp1 = 1;
-	atomic_count_t tmp2 = 0;
-	
-	volatile uintptr_t ptr = (uintptr_t) &val->count;
-	
+	uint64_t tmp1 = 1;
+	uint64_t tmp2 = 0;
+
+	volatile uintptr_t x = (uint64_t) &val->count;
+
 	preemption_disable();
-	
+
 	asm volatile (
-		"0:\n"
-			"casx %0, %3, %1\n"
-			"brz %1, 2f\n"
-			"nop\n"
-		"1:\n"
-			"ldx %0, %2\n"
-			"brz %2, 0b\n"
-			"nop\n"
-			"ba %%xcc, 1b\n"
-			"nop\n"
-		"2:\n"
-		: "+m" (*((atomic_count_t *) ptr)),
-		  "+r" (tmp1),
-		  "+r" (tmp2)
-		: "r" (0)
+	"0:\n"
+		"casx %0, %3, %1\n"
+		"brz %1, 2f\n"
+		"nop\n"
+	"1:\n"
+		"ldx %0, %2\n"
+		"brz %2, 0b\n"
+		"nop\n"
+		"ba %%xcc, 1b\n"
+		"nop\n"
+	"2:\n"
+		: "+m" (*((uint64_t *) x)), "+r" (tmp1), "+r" (tmp2) : "r" (0)
 	);
 	
Index: kernel/arch/sparc64/include/mm/as.h
===================================================================
--- kernel/arch/sparc64/include/mm/as.h	(revision aa85487c600b0fee35e8be1a6edd9b5b1a9a0646)
+++ kernel/arch/sparc64/include/mm/as.h	(revision 2e992773e5f019775f8da23f506b24fe7ec905b0)
@@ -36,9 +36,58 @@
 #define KERN_sparc64_AS_H_
 
-#if defined (SUN4U)
-#include <arch/mm/sun4u/as.h>
-#elif defined (SUN4V)
-#include <arch/mm/sun4v/as.h>
+#include <arch/mm/tte.h>
+
+#define KERNEL_ADDRESS_SPACE_SHADOWED_ARCH	1
+
+#define KERNEL_ADDRESS_SPACE_START_ARCH		(unsigned long) 0x0000000000000000
+#define KERNEL_ADDRESS_SPACE_END_ARCH		(unsigned long) 0xffffffffffffffff
+#define USER_ADDRESS_SPACE_START_ARCH		(unsigned long) 0x0000000000000000
+#define USER_ADDRESS_SPACE_END_ARCH		(unsigned long) 0xffffffffffffffff
+
+#define USTACK_ADDRESS_ARCH	(0xffffffffffffffffULL - (PAGE_SIZE - 1))
+
+#ifdef CONFIG_TSB
+
+/** TSB Tag Target register. */
+typedef union tsb_tag_target {
+	uint64_t value;
+	struct {
+		unsigned invalid : 1;	/**< Invalidated by software. */
+		unsigned : 2;
+		unsigned context : 13;	/**< Software ASID. */
+		unsigned : 6;
+		uint64_t va_tag : 42;	/**< Virtual address bits <63:22>. */
+	} __attribute__ ((packed));
+} tsb_tag_target_t;
+
+/** TSB entry. */
+typedef struct tsb_entry {
+	tsb_tag_target_t tag;
+	tte_data_t data;
+} __attribute__ ((packed)) tsb_entry_t;
+
+typedef struct {
+	tsb_entry_t *itsb;
+	tsb_entry_t *dtsb;
+} as_arch_t;
+
+#else
+
+typedef struct {
+} as_arch_t;
+
+#endif /* CONFIG_TSB */
+
+#include <genarch/mm/as_ht.h>
+
+#ifdef CONFIG_TSB
+#include <arch/mm/tsb.h>
+#define as_invalidate_translation_cache(as, page, cnt) \
+	tsb_invalidate((as), (page), (cnt))
+#else
+#define as_invalidate_translation_cache(as, page, cnt)
 #endif
+
+extern void as_arch_init(void);
 
 #endif
Index: kernel/arch/sparc64/include/mm/sun4u/tlb.h
===================================================================
--- kernel/arch/sparc64/include/mm/sun4u/tlb.h	(revision aa85487c600b0fee35e8be1a6edd9b5b1a9a0646)
+++ kernel/arch/sparc64/include/mm/sun4u/tlb.h	(revision 2e992773e5f019775f8da23f506b24fe7ec905b0)
@@ -684,5 +684,4 @@
 
 extern void dump_sfsr_and_sfar(void);
-extern void describe_dmmu_fault(void);
 
 #endif /* !def __ASM__ */
Index: kernel/arch/sparc64/include/mm/sun4v/frame.h
===================================================================
--- kernel/arch/sparc64/include/mm/sun4v/frame.h	(revision aa85487c600b0fee35e8be1a6edd9b5b1a9a0646)
+++ kernel/arch/sparc64/include/mm/sun4v/frame.h	(revision 2e992773e5f019775f8da23f506b24fe7ec905b0)
@@ -33,7 +33,12 @@
  */
 
-#ifndef KERN_sparc64_sun4v_FRAME_H_
-#define KERN_sparc64_sun4v_FRAME_H_
+#ifndef KERN_sparc64_SUN4V_FRAME_H_
+#define KERN_sparc64_SUN4V_FRAME_H_
 
+/*
+ * Page size supported by the MMU.
+ * For 8K there is the nasty illegal virtual aliasing problem.
+ * Therefore, the kernel uses 8K only internally on the TLB and TSB levels.
+ */
 #define MMU_FRAME_WIDTH		13	/* 8K */
 #define MMU_FRAME_SIZE		(1 << MMU_FRAME_WIDTH)
@@ -47,5 +52,24 @@
 #include <arch/types.h>
 
+union frame_address {
+	uintptr_t address;
+	struct {
+#if defined (US)
+		unsigned : 23;
+		uint64_t pfn : 28;		/**< Physical Frame Number. */
+#elif defined (US3)
+		unsigned : 21;
+		uint64_t pfn : 30;		/**< Physical Frame Number. */
+#endif
+		unsigned offset : 13;		/**< Offset. */
+	} __attribute__ ((packed));
+};
+
+typedef union frame_address frame_address_t;
+
 extern uintptr_t last_frame;
+//MH
+//extern uintptr_t end_of_identity;
+
 extern void frame_arch_init(void);
 #define physmem_print()
Index: kernel/arch/sparc64/include/mm/sun4v/mmu.h
===================================================================
--- kernel/arch/sparc64/include/mm/sun4v/mmu.h	(revision aa85487c600b0fee35e8be1a6edd9b5b1a9a0646)
+++ kernel/arch/sparc64/include/mm/sun4v/mmu.h	(revision 2e992773e5f019775f8da23f506b24fe7ec905b0)
@@ -28,5 +28,5 @@
  */
 
-/** @addtogroup sparc64mm
+/** @addtogroup sparc64mm	
  * @{
  */
@@ -45,4 +45,106 @@
 #define ASI_SECONDARY_CONTEXT_REG	0x21	/**< secondary context register ASI. */
 
+
+
+
+
+
+
+
+
+
+
+/* I-MMU ASIs. */
+#define ASI_IMMU			0x50
+#define ASI_IMMU_TSB_8KB_PTR_REG	0x51	
+#define ASI_IMMU_TSB_64KB_PTR_REG	0x52
+#define ASI_ITLB_DATA_IN_REG		0x54
+#define ASI_ITLB_DATA_ACCESS_REG	0x55
+#define ASI_ITLB_TAG_READ_REG		0x56
+#define ASI_IMMU_DEMAP			0x57
+
+/* Virtual Addresses within ASI_IMMU. */
+#define VA_IMMU_TSB_TAG_TARGET		0x0	/**< IMMU TSB tag target register. */
+#define VA_IMMU_SFSR			0x18	/**< IMMU sync fault status register. */
+#define VA_IMMU_TSB_BASE		0x28	/**< IMMU TSB base register. */
+#define VA_IMMU_TAG_ACCESS		0x30	/**< IMMU TLB tag access register. */
+#if defined (US3)
+#define VA_IMMU_PRIMARY_EXTENSION	0x48	/**< IMMU TSB primary extension register */
+#define VA_IMMU_NUCLEUS_EXTENSION	0x58	/**< IMMU TSB nucleus extension register */
+#endif
+
+
+/* D-MMU ASIs. */
+#define ASI_DMMU			0x58
+#define ASI_DMMU_TSB_8KB_PTR_REG	0x59	
+#define ASI_DMMU_TSB_64KB_PTR_REG	0x5a
+#define ASI_DMMU_TSB_DIRECT_PTR_REG	0x5b
+#define ASI_DTLB_DATA_IN_REG		0x5c
+#define ASI_DTLB_DATA_ACCESS_REG	0x5d
+#define ASI_DTLB_TAG_READ_REG		0x5e
+#define ASI_DMMU_DEMAP			0x5f
+
+/* Virtual Addresses within ASI_DMMU. */
+#define VA_DMMU_TSB_TAG_TARGET		0x0	/**< DMMU TSB tag target register. */
+#define VA_PRIMARY_CONTEXT_REG		0x8	/**< DMMU primary context register. */
+#define VA_SECONDARY_CONTEXT_REG	0x10	/**< DMMU secondary context register. */
+#define VA_DMMU_SFSR			0x18	/**< DMMU sync fault status register. */
+#define VA_DMMU_SFAR			0x20	/**< DMMU sync fault address register. */
+#define VA_DMMU_TSB_BASE		0x28	/**< DMMU TSB base register. */
+#define VA_DMMU_TAG_ACCESS		0x30	/**< DMMU TLB tag access register. */
+#define VA_DMMU_VA_WATCHPOINT_REG	0x38	/**< DMMU VA data watchpoint register. */
+#define VA_DMMU_PA_WATCHPOINT_REG	0x40	/**< DMMU PA data watchpoint register. */
+#if defined (US3)
+#define VA_DMMU_PRIMARY_EXTENSION	0x48	/**< DMMU TSB primary extension register */
+#define VA_DMMU_SECONDARY_EXTENSION	0x50	/**< DMMU TSB secondary extension register */
+#define VA_DMMU_NUCLEUS_EXTENSION	0x58	/**< DMMU TSB nucleus extension register */
+#endif
+
+#ifndef __ASM__
+
+#include <arch/asm.h>
+#include <arch/barrier.h>
+#include <arch/types.h>
+
+#if defined(US)
+/** LSU Control Register. */
+typedef union {
+	uint64_t value;
+	struct {
+		unsigned : 23;
+		unsigned pm : 8;
+		unsigned vm : 8;
+		unsigned pr : 1;
+		unsigned pw : 1;
+		unsigned vr : 1;
+		unsigned vw : 1;
+		unsigned : 1;
+		unsigned fm : 16;	
+		unsigned dm : 1;	/**< D-MMU enable. */
+		unsigned im : 1;	/**< I-MMU enable. */
+		unsigned dc : 1;	/**< D-Cache enable. */
+		unsigned ic : 1;	/**< I-Cache enable. */
+		
+	} __attribute__ ((packed));
+} lsu_cr_reg_t;
+#endif /* US */
+
+#endif /* !def __ASM__ */
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
 #endif
 
Index: kernel/arch/sparc64/include/mm/sun4v/tsb.h
===================================================================
--- kernel/arch/sparc64/include/mm/sun4v/tsb.h	(revision aa85487c600b0fee35e8be1a6edd9b5b1a9a0646)
+++ kernel/arch/sparc64/include/mm/sun4v/tsb.h	(revision 2e992773e5f019775f8da23f506b24fe7ec905b0)
@@ -28,5 +28,5 @@
  */
 
-/** @addtogroup sparc64mm
+/** @addtogroup sparc64mm	
  * @{
  */
@@ -71,5 +71,5 @@
 struct pte;
 
-extern void tsb_invalidate(struct as *as, uintptr_t page, uint64_t pages);
+extern void tsb_invalidate(struct as *as, uintptr_t page, count_t pages);
 extern void itsb_pte_copy(struct pte *t);
 extern void dtsb_pte_copy(struct pte *t, bool ro);
Index: kernel/arch/sparc64/include/mm/tsb.h
===================================================================
--- kernel/arch/sparc64/include/mm/tsb.h	(revision aa85487c600b0fee35e8be1a6edd9b5b1a9a0646)
+++ kernel/arch/sparc64/include/mm/tsb.h	(revision 2e992773e5f019775f8da23f506b24fe7ec905b0)
@@ -36,9 +36,134 @@
 #define KERN_sparc64_TSB_H_
 
-#if defined (SUN4U)
-#include <arch/mm/sun4u/tsb.h>
-#elif defined (SUN4V)
-#include <arch/mm/sun4v/tsb.h>
+/*
+ * ITSB abd DTSB will claim 64K of memory, which
+ * is a nice number considered that it is one of
+ * the page sizes supported by hardware, which,
+ * again, is nice because TSBs need to be locked
+ * in TLBs - only one TLB entry will do.
+ */
+#define TSB_SIZE			2	/* when changing this, change
+						 * as.c as well */
+#define ITSB_ENTRY_COUNT		(512 * (1 << TSB_SIZE))
+#define DTSB_ENTRY_COUNT		(512 * (1 << TSB_SIZE))
+
+#define TSB_TAG_TARGET_CONTEXT_SHIFT	48
+
+#ifndef __ASM__
+
+#include <arch/mm/tte.h>
+#include <arch/mm/mmu.h>
+#include <arch/types.h>
+
+/** TSB Base register. */
+typedef union tsb_base_reg {
+	uint64_t value;
+	struct {
+		uint64_t base : 51;	/**< TSB base address, bits 63:13. */
+		unsigned split : 1;	/**< Split vs. common TSB for 8K and 64K
+					 * pages. HelenOS uses only 8K pages
+					 * for user mappings, so we always set
+					 * this to 0.
+					 */
+		unsigned : 9;
+		unsigned size : 3;	/**< TSB size. Number of entries is
+					 * 512 * 2^size. */
+	} __attribute__ ((packed));
+} tsb_base_reg_t;
+
+/** Read ITSB Base register.
+ *
+ * @return Content of the ITSB Base register.
+ */
+static inline uint64_t itsb_base_read(void)
+{
+	return asi_u64_read(ASI_IMMU, VA_IMMU_TSB_BASE);
+}
+
+/** Read DTSB Base register.
+ *
+ * @return Content of the DTSB Base register.
+ */
+static inline uint64_t dtsb_base_read(void)
+{
+	return asi_u64_read(ASI_DMMU, VA_DMMU_TSB_BASE);
+}
+
+/** Write ITSB Base register.
+ *
+ * @param v New content of the ITSB Base register.
+ */
+static inline void itsb_base_write(uint64_t v)
+{
+	asi_u64_write(ASI_IMMU, VA_IMMU_TSB_BASE, v);
+}
+
+/** Write DTSB Base register.
+ *
+ * @param v New content of the DTSB Base register.
+ */
+static inline void dtsb_base_write(uint64_t v)
+{
+	asi_u64_write(ASI_DMMU, VA_DMMU_TSB_BASE, v);
+}
+
+#if defined (US3)
+
+/** Write DTSB Primary Extension register.
+ *
+ * @param v New content of the DTSB Primary Extension register.
+ */
+static inline void dtsb_primary_extension_write(uint64_t v)
+{
+	asi_u64_write(ASI_DMMU, VA_DMMU_PRIMARY_EXTENSION, v);
+}
+
+/** Write DTSB Secondary Extension register.
+ *
+ * @param v New content of the DTSB Secondary Extension register.
+ */
+static inline void dtsb_secondary_extension_write(uint64_t v)
+{
+	asi_u64_write(ASI_DMMU, VA_DMMU_SECONDARY_EXTENSION, v);
+}
+
+/** Write DTSB Nucleus Extension register.
+ *
+ * @param v New content of the DTSB Nucleus Extension register.
+ */
+static inline void dtsb_nucleus_extension_write(uint64_t v)
+{
+	asi_u64_write(ASI_DMMU, VA_DMMU_NUCLEUS_EXTENSION, v);
+}
+
+/** Write ITSB Primary Extension register.
+ *
+ * @param v New content of the ITSB Primary Extension register.
+ */
+static inline void itsb_primary_extension_write(uint64_t v)
+{
+	asi_u64_write(ASI_IMMU, VA_IMMU_PRIMARY_EXTENSION, v);
+}
+
+/** Write ITSB Nucleus Extension register.
+ *
+ * @param v New content of the ITSB Nucleus Extension register.
+ */
+static inline void itsb_nucleus_extension_write(uint64_t v)
+{
+	asi_u64_write(ASI_IMMU, VA_IMMU_NUCLEUS_EXTENSION, v);
+}
+
 #endif
+
+/* Forward declarations. */
+struct as;
+struct pte;
+
+extern void tsb_invalidate(struct as *as, uintptr_t page, size_t pages);
+extern void itsb_pte_copy(struct pte *t, size_t index);
+extern void dtsb_pte_copy(struct pte *t, size_t index, bool ro);
+
+#endif /* !def __ASM__ */
 
 #endif
Index: kernel/arch/sparc64/include/sun4v/arch.h
===================================================================
--- kernel/arch/sparc64/include/sun4v/arch.h	(revision aa85487c600b0fee35e8be1a6edd9b5b1a9a0646)
+++ kernel/arch/sparc64/include/sun4v/arch.h	(revision 2e992773e5f019775f8da23f506b24fe7ec905b0)
@@ -58,4 +58,9 @@
 #define SCRATCHPAD_WBUF		0x18
 
+//MH - remove when cpu.h is forked
+#define ASI_NUCLEUS_QUAD_LDD	0x24	/** ASI for 16-byte atomic loads. */
+#define ASI_DCACHE_TAG		0x47	/** ASI D-Cache Tag. */
+#define ASI_ICBUS_CONFIG	0x4a	/** ASI of the UPA_CONFIG/FIREPLANE_CONFIG register. */
+
 #endif
 
Index: kernel/arch/sparc64/include/sun4v/cpu.h
===================================================================
--- kernel/arch/sparc64/include/sun4v/cpu.h	(revision aa85487c600b0fee35e8be1a6edd9b5b1a9a0646)
+++ kernel/arch/sparc64/include/sun4v/cpu.h	(revision 2e992773e5f019775f8da23f506b24fe7ec905b0)
@@ -44,9 +44,7 @@
 #ifndef __ASM__
 
-#include <atomic.h>
-#include <synch/spinlock.h>
-
 struct cpu;
 
+/*
 typedef struct {
 	uint64_t exec_unit_id;
@@ -57,4 +55,5 @@
 	SPINLOCK_DECLARE(proposed_nrdy_lock);
 } exec_unit_t;
+*/
 
 typedef struct cpu_arch {
@@ -64,7 +63,7 @@
 					     generated when the TICK register
 					     matches this value. */
-	exec_unit_t *exec_unit;		/**< Physical core. */
-	unsigned long proposed_nrdy;	/**< Proposed No. of ready threads
-					     so that cores are equally balanced. */
+	//exec_unit_t *exec_unit;		/**< Physical core. */
+	//unsigned long proposed_nrdy;	/**< Proposed No. of ready threads
+	//				     so that cores are equally balanced. */
 } cpu_arch_t;
 
Index: kernel/arch/sparc64/include/sun4v/hypercall.h
===================================================================
--- kernel/arch/sparc64/include/sun4v/hypercall.h	(revision aa85487c600b0fee35e8be1a6edd9b5b1a9a0646)
+++ kernel/arch/sparc64/include/sun4v/hypercall.h	(revision 2e992773e5f019775f8da23f506b24fe7ec905b0)
@@ -75,22 +75,22 @@
 
 /* return codes */
-#define HV_EOK			0	/**< Successful return */
-#define HV_ENOCPU		1	/**< Invalid CPU id */
-#define HV_ENORADDR		2	/**< Invalid real address */
-#define HV_ENOINTR		3	/**< Invalid interrupt id */
-#define HV_EBADPGSZ		4	/**< Invalid pagesize encoding */
-#define HV_EBADTSB		5	/**< Invalid TSB description */
-#define	HV_EINVAL		6	/**< Invalid argument */
-#define HV_EBADTRAP		7	/**< Invalid function number */
-#define HV_EBADALIGN		8	/**< Invalid address alignment */
-#define HV_EWOULDBLOCK		9	/**< Cannot complete operation without blocking */
-#define HV_ENOACCESS		10	/**< No access to specified resource */
-#define HV_EIO			11	/**< I/O Error */
-#define HV_ECPUERROR		12	/**< CPU is in error state */
-#define HV_ENOTSUPPORTED	13	/**< Function not supported */
-#define HV_ENOMAP		14	/**< No mapping found */
-#define HV_ETOOMANY		15	/**< Too many items specified / limit reached */
-#define HV_ECHANNEL		16	/**< Invalid LDC channel */
-#define HV_EBUSY		17	/**< Operation failed as resource is otherwise busy */
+#define EOK		0	/**< Successful return */
+#define ENOCPU		1	/**< Invalid CPU id */
+#define ENORADDR	2	/**< Invalid real address */
+#define ENOINTR		3	/**< Invalid interrupt id */
+#define EBADPGSZ	4	/**< Invalid pagesize encoding */
+#define EBADTSB		5	/**< Invalid TSB description */
+#define	EINVAL		6	/**< Invalid argument */
+#define EBADTRAP	7	/**< Invalid function number */
+#define EBADALIGN	8	/**< Invalid address alignment */
+#define EWOULDBLOCK	9	/**< Cannot complete operation without blocking */
+#define ENOACCESS	10	/**< No access to specified resource */
+#define EIO		11	/**< I/O Error */
+#define ECPUERROR	12	/**< CPU is in error state */
+#define ENOTSUPPORTED	13	/**< Function not supported */
+#define ENOMAP		14	/**< No mapping found */
+#define ETOOMANY	15	/**< Too many items specified / limit reached */
+#define ECHANNEL	16	/**< Invalid LDC channel */
+#define EBUSY		17	/**< Operation failed as resource is otherwise busy */
 
 
@@ -190,25 +190,11 @@
 __hypercall_fast_ret1(const uint64_t p1, const uint64_t p2, const uint64_t p3,
     const uint64_t p4, const uint64_t p5, const uint64_t function_number,
-    uint64_t *ret1)
+    uint64_t * const ret1)
 {
-	register uint64_t a6 asm("o5") = function_number;
-	register uint64_t a1 asm("o0") = p1;
-	register uint64_t a2 asm("o1") = p2;
-	register uint64_t a3 asm("o2") = p3;
-	register uint64_t a4 asm("o3") = p4;
-	register uint64_t a5 asm("o4") = p5;
-	
-	asm volatile (
-		"ta %8\n"
-		: "=r" (a1), "=r" (a2)
-		: "r" (a1), "r" (a2), "r" (a3), "r" (a4), "r" (a5), "r" (a6),
-		  "i" (FAST_TRAP)
-		: "memory"
-	);
-
-	if (ret1)
-		*ret1 = a2;
-
-	return a1;
+	uint64_t errno = __hypercall_fast(p1, p2, p3, p4, p5, function_number);
+	if (ret1 != NULL) {
+		asm volatile ("mov %%o1, %0\n" : "=r" (*ret1));
+	}
+	return errno;
 }
 
Index: kernel/arch/sparc64/include/sun4v/ipi.h
===================================================================
--- kernel/arch/sparc64/include/sun4v/ipi.h	(revision aa85487c600b0fee35e8be1a6edd9b5b1a9a0646)
+++ kernel/arch/sparc64/include/sun4v/ipi.h	(revision 2e992773e5f019775f8da23f506b24fe7ec905b0)
@@ -38,8 +38,7 @@
 #define KERN_sparc64_sun4v_IPI_H_
 
-#include <arch/types.h>
-
-extern uint64_t ipi_brodcast_to(void (*)(void), uint16_t cpu_list[], uint64_t);
-extern uint64_t ipi_unicast_to(void (*)(void), uint16_t);
+uint64_t ipi_brodcast_to(void (*func)(void), uint16_t cpu_list[MAX_NUM_STRANDS],
+		uint64_t list_size);
+uint64_t ipi_unicast_to(void (*func)(void), uint16_t cpu_id);
 
 #endif
Index: kernel/arch/sparc64/include/trap/exception.h
===================================================================
--- kernel/arch/sparc64/include/trap/exception.h	(revision aa85487c600b0fee35e8be1a6edd9b5b1a9a0646)
+++ kernel/arch/sparc64/include/trap/exception.h	(revision 2e992773e5f019775f8da23f506b24fe7ec905b0)
@@ -38,16 +38,9 @@
 
 #define TT_INSTRUCTION_ACCESS_EXCEPTION		0x08
-#define TT_INSTRUCTION_ACCESS_MMU_MISS		0x09
 #define TT_INSTRUCTION_ACCESS_ERROR		0x0a
-#define	TT_IAE_UNAUTH_ACCESS			0x0b
-#define	TT_IAE_NFO_PAGE				0x0c
 #define TT_ILLEGAL_INSTRUCTION			0x10
 #define TT_PRIVILEGED_OPCODE			0x11
 #define TT_UNIMPLEMENTED_LDD			0x12
 #define TT_UNIMPLEMENTED_STD			0x13
-#define TT_DAE_INVALID_ASI			0x14
-#define TT_DAE_PRIVILEGE_VIOLATION		0x15
-#define TT_DAE_NC_PAGE				0x16
-#define TT_DAE_NFO_PAGE				0x17
 #define TT_FP_DISABLED				0x20
 #define TT_FP_EXCEPTION_IEEE_754		0x21
@@ -56,5 +49,4 @@
 #define TT_DIVISION_BY_ZERO			0x28
 #define TT_DATA_ACCESS_EXCEPTION		0x30
-#define TT_DATA_ACCESS_MMU_MISS			0x31
 #define TT_DATA_ACCESS_ERROR			0x32
 #define TT_MEM_ADDRESS_NOT_ALIGNED		0x34
Index: kernel/arch/sparc64/include/trap/interrupt.h
===================================================================
--- kernel/arch/sparc64/include/trap/interrupt.h	(revision aa85487c600b0fee35e8be1a6edd9b5b1a9a0646)
+++ kernel/arch/sparc64/include/trap/interrupt.h	(revision 2e992773e5f019775f8da23f506b24fe7ec905b0)
@@ -32,9 +32,66 @@
 /** 
  * @file
- * @brief This file contains level N interrupt and inter-processor interrupt
- * trap handler.
+ * @brief This file contains interrupt vector trap handler.
  */
-#ifndef KERN_sparc64_INTERRUPT_TRAP_H_
-#define KERN_sparc64_INTERRUPT_TRAP_H_
+
+#ifndef KERN_sparc64_TRAP_INTERRUPT_H_
+#define KERN_sparc64_TRAP_INTERRUPT_H_
+
+#include <arch/trap/trap_table.h>
+#include <arch/stack.h>
+
+/* IMAP register bits */
+#define IGN_MASK	0x7c0
+#define INO_MASK	0x1f
+#define IMAP_V_MASK	(1ULL << 31)
+
+#define IGN_SHIFT	6
+
+
+/* Interrupt ASI registers. */
+#define ASI_INTR_W			0x77
+#define ASI_INTR_DISPATCH_STATUS	0x48
+#define ASI_INTR_R			0x7f
+#define ASI_INTR_RECEIVE		0x49
+
+/* VA's used with ASI_INTR_W register. */
+#if defined (US)
+#define ASI_UDB_INTR_W_DATA_0	0x40
+#define ASI_UDB_INTR_W_DATA_1	0x50
+#define ASI_UDB_INTR_W_DATA_2	0x60
+#elif defined (US3)
+#define VA_INTR_W_DATA_0	0x40
+#define VA_INTR_W_DATA_1	0x48
+#define VA_INTR_W_DATA_2	0x50
+#define VA_INTR_W_DATA_3	0x58
+#define VA_INTR_W_DATA_4	0x60
+#define VA_INTR_W_DATA_5	0x68
+#define VA_INTR_W_DATA_6	0x80
+#define VA_INTR_W_DATA_7	0x88
+#endif
+#define VA_INTR_W_DISPATCH	0x70
+
+/* VA's used with ASI_INTR_R register. */
+#if defined(US)
+#define ASI_UDB_INTR_R_DATA_0	0x40
+#define ASI_UDB_INTR_R_DATA_1	0x50
+#define ASI_UDB_INTR_R_DATA_2	0x60
+#elif defined (US3)
+#define VA_INTR_R_DATA_0	0x40
+#define VA_INTR_R_DATA_1	0x48
+#define VA_INTR_R_DATA_2	0x50
+#define VA_INTR_R_DATA_3	0x58
+#define VA_INTR_R_DATA_4	0x60
+#define VA_INTR_R_DATA_5	0x68
+#define VA_INTR_R_DATA_6	0x80
+#define VA_INTR_R_DATA_7	0x88
+#endif
+
+/* Shifts in the Interrupt Vector Dispatch virtual address. */
+#define INTR_VEC_DISPATCH_MID_SHIFT	14
+
+/* Bits in the Interrupt Dispatch Status register. */
+#define INTR_DISPATCH_STATUS_NACK	0x2
+#define INTR_DISPATCH_STATUS_BUSY	0x1
 
 #define TT_INTERRUPT_LEVEL_1			0x41
@@ -54,13 +111,8 @@
 #define TT_INTERRUPT_LEVEL_15			0x4f
 
+#define TT_INTERRUPT_VECTOR_TRAP		0x60
+
 #define INTERRUPT_LEVEL_N_HANDLER_SIZE		TRAP_TABLE_ENTRY_SIZE
-
-/* IMAP register bits */
-#define IGN_MASK	0x7c0
-#define INO_MASK	0x1f
-#define IMAP_V_MASK	(1ULL << 31)
-
-#define IGN_SHIFT	6
-
+#define INTERRUPT_VECTOR_TRAP_HANDLER_SIZE	TRAP_TABLE_ENTRY_SIZE
 
 #ifdef __ASM__
@@ -69,5 +121,9 @@
 	PREEMPTIBLE_HANDLER exc_dispatch
 .endm
-#endif
+
+.macro INTERRUPT_VECTOR_TRAP_HANDLER
+	PREEMPTIBLE_HANDLER interrupt
+.endm
+#endif /* __ASM__ */
 
 #ifndef __ASM__
@@ -78,11 +134,4 @@
 #endif /* !def __ASM__ */
 
-
-#if defined (SUN4U)
-#include <arch/trap/sun4u/interrupt.h>
-#elif defined (SUN4V)
-#include <arch/trap/sun4v/interrupt.h>
-#endif
-
 #endif
 
Index: kernel/arch/sparc64/include/trap/regwin.h
===================================================================
--- kernel/arch/sparc64/include/trap/regwin.h	(revision aa85487c600b0fee35e8be1a6edd9b5b1a9a0646)
+++ kernel/arch/sparc64/include/trap/regwin.h	(revision 2e992773e5f019775f8da23f506b24fe7ec905b0)
@@ -183,5 +183,4 @@
 	add %l0, 1, %l0
 	wrpr %l0, 0, %cleanwin
-#if defined(SUN4U)
 	mov %r0, %l0
 	mov %r0, %l1
@@ -200,12 +199,11 @@
 	mov %r0, %o6
 	mov %r0, %o7
-#endif
 	retry
 .endm
 #endif /* __ASM__ */
 
-#if defined(SUN4U)
+#if defined (SUN4U)
 #include <arch/trap/sun4u/regwin.h>
-#elif defined(SUN4V)
+#elif defined (SUN4V)
 #include <arch/trap/sun4v/regwin.h>
 #endif
Index: kernel/arch/sparc64/include/trap/sun4v/mmu.h
===================================================================
--- kernel/arch/sparc64/include/trap/sun4v/mmu.h	(revision aa85487c600b0fee35e8be1a6edd9b5b1a9a0646)
+++ kernel/arch/sparc64/include/trap/sun4v/mmu.h	(revision 2e992773e5f019775f8da23f506b24fe7ec905b0)
@@ -36,6 +36,6 @@
  */
 
-#ifndef KERN_sparc64_sun4v_MMU_TRAP_H_
-#define KERN_sparc64_sun4v_MMU_TRAP_H_
+#ifndef KERN_sparc64_SUN4V_MMU_TRAP_H_
+#define KERN_sparc64_SUN4V_MMU_TRAP_H_
 
 #include <arch/stack.h>
@@ -121,7 +121,8 @@
 	 * but this time its handler accesse memory which IS mapped.
 	 */
-	.if (\tl > 0)
-		wrpr %g0, 1, %tl
-	.endif
+0:
+.if (\tl > 0)
+	wrpr %g0, 1, %tl
+.endif
 
 	/*
Index: kernel/arch/sparc64/include/trap/trap_table.h
===================================================================
--- kernel/arch/sparc64/include/trap/trap_table.h	(revision aa85487c600b0fee35e8be1a6edd9b5b1a9a0646)
+++ kernel/arch/sparc64/include/trap/trap_table.h	(revision 2e992773e5f019775f8da23f506b24fe7ec905b0)
@@ -101,5 +101,5 @@
 .macro PREEMPTIBLE_HANDLER f
 	sethi %hi(\f), %g1
-	b preemptible_handler
+	ba %xcc, preemptible_handler
 	or %g1, %lo(\f), %g1
 .endm
Index: kernel/arch/sparc64/include/types.h
===================================================================
--- kernel/arch/sparc64/include/types.h	(revision aa85487c600b0fee35e8be1a6edd9b5b1a9a0646)
+++ kernel/arch/sparc64/include/types.h	(revision 2e992773e5f019775f8da23f506b24fe7ec905b0)
@@ -27,5 +27,5 @@
  */
 
-/** @addtogroup sparc64
+/** @addtogroup sparc64	
  * @{
  */
@@ -55,5 +55,4 @@
 typedef uint64_t unative_t;
 typedef int64_t native_t;
-typedef uint64_t atomic_count_t;
 
 typedef struct {
Index: kernel/arch/sparc64/src/cpu/sun4u/cpu.c
===================================================================
--- kernel/arch/sparc64/src/cpu/sun4u/cpu.c	(revision aa85487c600b0fee35e8be1a6edd9b5b1a9a0646)
+++ kernel/arch/sparc64/src/cpu/sun4u/cpu.c	(revision 2e992773e5f019775f8da23f506b24fe7ec905b0)
@@ -129,6 +129,5 @@
 void cpu_print_report(cpu_t *m)
 {
-	const char *manuf;
-	const char *impl;
+	char *manuf, *impl;
 
 	switch (m->arch.ver.manuf) {
Index: kernel/arch/sparc64/src/cpu/sun4v/cpu.c
===================================================================
--- kernel/arch/sparc64/src/cpu/sun4v/cpu.c	(revision aa85487c600b0fee35e8be1a6edd9b5b1a9a0646)
+++ kernel/arch/sparc64/src/cpu/sun4v/cpu.c	(revision 2e992773e5f019775f8da23f506b24fe7ec905b0)
@@ -1,5 +1,4 @@
 /*
  * Copyright (c) 2005 Jakub Jermar
- * Copyright (c) 2009 Pavel Rimsky
  * All rights reserved.
  *
@@ -41,5 +40,6 @@
 #include <arch/sun4v/md.h>
 #include <arch/sun4v/hypercall.h>
-#include <arch/trap/sun4v/interrupt.h>
+
+//#include <arch/trap/sun4v/interrupt.h>
 
 /** Perform sparc64 specific initialization of the processor structure for the
@@ -51,5 +51,6 @@
 	__hypercall_fast_ret1(0, 0, 0, 0, 0, CPU_MYID, &myid);
 
-	CPU->arch.id = myid;
+	//MH
+	//CPU->arch.id = myid;
 
 	md_node_t node = md_get_root();
@@ -73,6 +74,6 @@
 		
 	tick_init();
-
-	sun4v_ipi_init();
+    	//MH - uncomment later
+	//sun4v_ipi_init();
 }
 
@@ -95,5 +96,5 @@
 {
 	printf("cpu%d: Niagara (%d MHz)\n", m->id,
-	    m->arch.clock_frequency / 1000000);
+		m->arch.clock_frequency / 1000000);
 }
 
Index: kernel/arch/sparc64/src/drivers/niagara.c
===================================================================
--- kernel/arch/sparc64/src/drivers/niagara.c	(revision aa85487c600b0fee35e8be1a6edd9b5b1a9a0646)
+++ kernel/arch/sparc64/src/drivers/niagara.c	(revision 2e992773e5f019775f8da23f506b24fe7ec905b0)
@@ -104,5 +104,5 @@
 static inline void do_putchar(const char c) {
 	/* repeat until the buffer is non-full */
-	while (__hypercall_fast1(CONS_PUTCHAR, c) == HV_EWOULDBLOCK)
+	while (__hypercall_fast1(CONS_PUTCHAR, c) == EWOULDBLOCK)
 		;
 }
@@ -111,7 +111,4 @@
 static void niagara_putchar(outdev_t *dev, const wchar_t ch, bool silent)
 {
-        if (silent)
-            return;
-
 	do_putchar(ch);
 	if (ch == '\n')
@@ -139,5 +136,5 @@
 
 	/* read character from keyboard, send it to upper layers of HelenOS */
-	if (__hypercall_fast_ret1(0, 0, 0, 0, 0, CONS_GETCHAR, &c) == HV_EOK) {
+	if (__hypercall_fast_ret1(0, 0, 0, 0, 0, CONS_GETCHAR, &c) == EOK) {
 		if (!silent) {
 			/* kconsole active, send the character to kernel */
Index: kernel/arch/sparc64/src/mm/sun4u/tlb.c
===================================================================
--- kernel/arch/sparc64/src/mm/sun4u/tlb.c	(revision aa85487c600b0fee35e8be1a6edd9b5b1a9a0646)
+++ kernel/arch/sparc64/src/mm/sun4u/tlb.c	(revision 2e992773e5f019775f8da23f506b24fe7ec905b0)
@@ -64,5 +64,5 @@
     tlb_tag_access_reg_t, const char *);
 
-const char *context_encoding[] = {
+char *context_encoding[] = {
 	"Primary",
 	"Secondary",
@@ -476,5 +476,5 @@
 }
 
-void describe_dmmu_fault(void)
+void dump_sfsr_and_sfar(void)
 {
 	tlb_sfsr_reg_t sfsr;
@@ -499,27 +499,4 @@
 }
 
-void dump_sfsr_and_sfar(void)
-{
-	tlb_sfsr_reg_t sfsr;
-	uintptr_t sfar;
-
-	sfsr.value = dtlb_sfsr_read();
-	sfar = dtlb_sfar_read();
-	
-#if defined (US)
-	printf("DTLB SFSR: asi=%#x, ft=%#x, e=%d, ct=%d, pr=%d, w=%d, ow=%d, "
-	    "fv=%d\n", sfsr.asi, sfsr.ft, sfsr.e, sfsr.ct, sfsr.pr, sfsr.w,
-	    sfsr.ow, sfsr.fv);
-#elif defined (US3)
-	printf("DTLB SFSR: nf=%d, asi=%#x, tm=%d, ft=%#x, e=%d, ct=%d, pr=%d, "
-	    "w=%d, ow=%d, fv=%d\n", sfsr.nf, sfsr.asi, sfsr.tm, sfsr.ft,
-	    sfsr.e, sfsr.ct, sfsr.pr, sfsr.w, sfsr.ow, sfsr.fv);
-#endif
-	    
-	printf("DTLB SFAR: address=%p\n", sfar);
-	
-	dtlb_sfsr_write(0);
-}
-
 #if defined (US)
 /** Invalidate all unlocked ITLB and DTLB entries. */
